#! /usr/bin/perl -w

use strict;
use locale;

#	This script creates individual annotation files from a single file 
#	containing multiple concatenated CDG annotations. The files are first
#	created and numbered. Then, those files containing fewer digits in their
#	filename than the maximum number of digits are renamed to contain leading zeroes.

# 	Invocation Arguments:
#	=====================
#	1. van Kampen corpus file

# First create the individual numbered files.

my $counter;

while ( <> )
{
	next if /^$/;
	
	if ( /wordgraph/ )
	{       
		$counter ++;
		open OUTPUT, ">", "./Annotation_$counter.cda";
	}
	
	print OUTPUT $_;
}

# Then rename the files not containing the right number of digits.

my $number = length $counter;
my $num = $number - 1;

die if ( $number <= 1 );	# End the programme if less than 10 files were created an no renaming is required.

for my $file ( glob "*" )
{
	next unless $file =~ /(.*_)(\d{1,$num})(.cda)/;		# Only rename if the filename contains fewer than the maximum number of digits.
	
	my $zeroes = "0" x ( $number - length $2 );
	rename $file, $1.$zeroes.$2.$3;
}
