#! /usr/bin/perl -w

use strict;
use locale;

#	This script removes a set of annotations from a CDG annotation file.
#	The numbers of the sentences for which annotations are to be removed are 
#	obtained from an input file.
#
#	Invocation Arguments
#	====================
#	1. CDG annotation file from which to remove selected annotations.
#	2. File(s) containing the sentence numbers to remove or sentence numbers to remove.


my %remove;

open ANNOTATIONS, "<", shift @ARGV;

for my $argument ( @ARGV )
{
	if ( -f $argument ) # If the invocation argument is a file, read in the numbers from the file.
	{
		open EXTRACT, "<", $argument or die "Could not open the file $argument.";
		
		$remove{ $_ } ++ for <EXTRACT>;
	}
	else 	# If the invocation argument is not a file, read in the number from the argument.
	{
			$remove{ $argument } ++;	
	}
}

print "There are ", scalar keys %include, " sentences for with an annotation needs to be included.\n";

my $counter = 0;

while ( <ANNOTATIONS> )
{
   $counter ++ if /wordgraph/o;
   print "$counter $remove{ $counter }";
   print $_ unless ( defined $remove{ $counter } );
} 
