package cia_components.reasoning;

import edu.stanford.smi.protegex.owl.model.OWLModel;
// import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
import edu.stanford.smi.protegex.owl.ProtegeOWL;
import edu.stanford.smi.protegex.owl.inference.protegeowl.ReasonerManager;
import edu.stanford.smi.protegex.owl.inference.protegeowl.ProtegeOWLReasoner;

// import java.util.Iterator;
// import java.util.Collection;
// import java.net.*;
import java.io.*;

public class Connector
{
	ReasonerManager reasonerManager;
	ProtegeOWLReasoner reasoner;
	OWLModel owl_model;
	
	public Connector()
	{
		load_Context_Model();	
		connect_Reasoner();
	}
	
	
	public void load_Context_Model()
	{
		File context_model = new File( System.getenv( "CONTEXT_MODEL" ) );
		
		// Load the context_model (the OWL model) via its absolute path in URI format (i. e.: file:/path ) handed over as a string.
		try
		{
			owl_model = ProtegeOWL.createJenaOWLModelFromURI( context_model.toURI().toString() );
		}
		catch ( Exception e )
		{
			System.err.println( "Could not load Context Model " + System.getenv( "CONTEXT_MODEL" ) + "because: \n " + e.getMessage() );
		}
	}
	
	
	public void connect_Reasoner()
	{
		// Create a reasoner manager and from it obtain a reasoner for the OWL model.		
		reasonerManager = ReasonerManager.getInstance();


		reasoner = reasonerManager.getReasoner( owl_model );

		// Set the reasoner URL and test the connection
		reasoner.setURL( System.getenv( "REASONER_URL" ) );
			
		if( ! reasoner.isConnected() ) 
		{
			System.out.println( "***************** Reasoner not connected." );
		}
	}
	
	
	public ProtegeOWLReasoner get_Reasoner()
	{
		return reasoner;
	}
	
	
	public OWLModel get_OWL_Model()
	{
		return owl_model;
	}	
}