#!/usr/bin/perl

########################################################################
#                                                                      #
# Author: Roerd Hinrichsen                                             #
# Time-stamp: <25-Aug-2009 17:15:43 5hinrich>                          #
#                                                                      #
# Count the number of classes, individuals and relations in the T-Box. #
#                                                                      #
# Parse the T-Box XML file and print the number of unique assertions   #
# of the mentioned kinds of elements.                                  #
#                                                                      #
########################################################################

use strict;
use warnings;
use XML::Parser;

my %classes;
my %individuals;
my %relations;

sub Class {
    for (my $i = 2; $i < @_; $i += 2) {
	if ($_[$i] eq "URI") {
	    $classes{$_[$i + 1]} = 1;
	}
    }
}

sub Individual {
    for (my $i = 2; $i < @_; $i += 2) {
	if ($_[$i] eq "URI") {
	    $individuals{$_[$i + 1]} = 1;
	}
    }
}

sub ObjectProperty {
    for (my $i = 2; $i < @_; $i += 2) {
	if ($_[$i] eq "URI") {
	    $relations{$_[$i + 1]} = 1;
	}
    }
}

my $p = new XML::Parser(Style => 'Subs');
my $file = $ARGV[0] || 'T-Box.owl';
$p->parsefile($file);

print keys(%classes) . " classes,\n";
print keys(%individuals) . " individuals,\n";
print keys(%relations) . " relations.\n"
