/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* ---------------------------------------------------------------------------- 
  local typemaps 
 */

%{
  #include <hooker.h>
%}

#ifdef SWIGTCL

%typemap(out) TclResultType {
  /* tcl8, out int typemap */
  if ($1 != TCL_OK && hkResult->type != HTError) {
    SWIG_fail;
  } else {
    Tcl_Obj *tclResult = $result;
    int tempi;

    switch (hkResult->type) {
      case HTNone:
	break;
      case HTInt:
	Tcl_SetIntObj(tclResult, hkResult->data.intResult);
	break;
      case HTString:
	Tcl_SetStringObj(tclResult, hkResult->data.stringResult, -1);
	break;
     case HTError:
	if (hkResult->hook) {
	  Tcl_AppendStringsToObj(tclResult, ": error in hook `", 
  	    hkResult->hook->name, "' : disabled", (char *)NULL);
	  hkResult->hook->active = FALSE;
	} else {
  	  Tcl_AppendStringsToObj(tclResult, hkResult->data.stringResult, 
	    (char *) NULL);
	}
	SWIG_fail;
      default:
	Tcl_AppendStringsToObj(tclResult, "unknown hkResult ... abording", (char *)NULL);
	fprintf(stderr, "ERROR: unknown hkResult %d ...abording\n", hkResult->type); 
	SWIG_fail;
    }
  }
}

#endif

%include "hook.h";
%include "hooker.h";
