// Die Ebene ARG drckt semantische Rollen aus.
ARG     #
 '[-dep]', '[+-dep]', '[+dep]', '';


{X:ARG\Y|SYN} : 'Teilweise genutzter virtueller Knoten (ARG)' : virtual : 0.0 : 
  virtual(Y@id, "definition") & Y.label = '' -> false;

{X!ARG} : 'virtueller Regent (ARG)' : virtual : 0.95 : (context) :
   virtual(X^id, "definition") -> false;


// Nominale sind Ausgangspunkt einer ARG-Kante.
{X:ARG\/Y:SYN} : 'ARG-Definition' : arg : 0.0 :
  ~ isa(X@,Nominal) 
  | virtual(Y@id, "definition") & Y.label='' & root(Y^id)
  // CJ werden ausgenommen, da die gesamte Konjunktion das Argument ist.
  | Y.label = CJ
  // APP werden ausgenommen
  | Y.label = APP
  // TODO: PN drfen nur Argument sein, wenn sie dem Verb zugeordnet werden.
  | Y.label = PN
  <-> root(X^id);

// ARG-Kanten nach NIL haben das leere Label
{X|ARG} : 'NIL-Definition (ARG)' : arg : 0.0 :
  X.label = '';

// Alle Kanten mit dem leeren Label gehen nach NIL
{X!ARG} : 'NIL-Label (ARG)' : arg : 0.0 :
  X.label != '';


// Nur Nominale und finite Verben kommen als Zielpunkt einer ARG-Kante in Frage.
// eine ARG Kante darf nicht bei einem PN ankommen
{X!ARG\Y:SYN} : 'ARG-Kategorie' : arg : 0.0 :
  (isa(X^,Nominal)
  // TODO PN (siehe oben)
  & Y.label != CJ
  & Y.label != APP
  & Y.label != PN) |
  isa(X^,finit);


// Kante zum finiten Verb heit [-dep]
{X!ARG\/Y:SYN} : 'Verbindung zum Verb muss [-dep] sein' : arg : 0.5 :
  isa(X^,finit) <->
   X.label = '[-dep]';

// Verb muss in der gleichen Sub-clause sein
//{X!ARG\/Y:SYN} : 'Verb nicht in gleicher Sub-Clause' : arg : 0.5 :
//  isa(X^,finit) ->
//  ~between(X@id, X^id, ",");

{X!ARG} : 'Argumente sind nicht in der gleichen Sub-Clause' : arg : 0.5 :
  ~between(X@id, X^id, ",");

// 
{X!ARG\/Y:SYN} : 'Verb fordert SUBJ als [-dep]' : arg : 0.5 :
  isa(X^,finit) & ~ exists(X^obj_experiencer) ->
    exists(X@case)
    & compatible(Features, nom, X@case)
    & Y.label = SUBJ;

//
{X!ARG\/Y:SYN} : 'obj experiencer verb fordert Objekt als [-dep]' : arg : 0.5 :
  isa(X^,finit) & exists(X^obj_experiencer) ->
    exists(X@case)
    & compatible(Features, X^obj_experiencer, X@case)
    & subsumes(ObjectExperiencer, X^obj_experiencer, Y.label);


// Zwei ARG-Kanten drfen sich bei einem Wort nicht treffen.
{X!ARG/\Y!ARG} : 'ARG-Kollision' : arg : 0.5 :
  false;


// Zwischen zwei Argumenten kann es nur eine Kante geben.
{X!ARG/Y!ARG} : 'bidirektionale ARG-Kante' : arg : 0.5 :
  X^id != Y@id;

// Die ARG-Kante, die unterhalb einer anderen liegt muss auch ein 
// Label tragen , dass in der Argument-Hierarchie unter dem der ersten Kante liegt.
{X!ARG/Y!ARG} : 'Hierarchie nicht beachtet' : arg : 0.5 :
  subsumes(ArgLabel, X.label, Y.label)
  & Y.label != X.label;

{X!ARG/Y!ARG} : 'Rollen sollten maximal auseinander liegen' : arg : 0.99 :
  subsumes(ArgLabelBig, X.label, Y.label)
  & Y.label != X.label;

// Hierarchie fr die ARG-Label

ArgLabel ->
  '[-dep]' -> '[+-dep]',
  '[+-dep]' -> '[+dep]',
  '[+dep]' -> '';

ArgLabelBig ->
  '[-dep]' -> '[+dep]',
  '[+-dep]' -> '[+dep]',
  '[+dep]' -> '';

ObjectExperiencer ->
  dat -> OBJD ETH,
  nil -> ADV APP ATTR AUX AVZ CJ DET EXPL GMOD GRAD KOM KON KONJ NEB NP2 OBJA OBJA2 OBJG OBJC OBJI OBJP PAR PART PN PP PRED REL S SUBJ SUBJC VOK ZEIT '';
