
// Used for the freezing heuristics in incremental parsing
// Dependencies with this label may not be deleted due to freezing, because dependencies are nonlocal
// e.g. REL and NEB edges are notoriously nonprojective and may point into otherwise stable subtress
// GMOD is projective, but reasons for switching to GMOD interpretation may come much later
LabelExceptions (
	REL, 
	NEB,
	GMOD);

// used for the freezing heuristics in incremental parsing
// frozen edges need to stay flexible regarding these attributes
LexemeAttributeExceptions (
	case,
	loctype,
	number,
	flextion);

// groups of labels in the Labels hierarchy, where labels from the same group should be considered as compatible regarding virtual node matching
LabelGroups (
	Nominalobjekt,
	verbletzt,
	Nachfeld);


// virtual nodes //////////////////

// generic nominals
virtualnode : virtNom : 0.95 : 2 :
 [ cat:NN, base:unknown, person:bot, gender:bot, number:bot, case:nom_dat_acc, sort:bot ] ,
 [ cat:NN, base:unknown, person:bot, gender:bot, number:bot, case:gen        , sort:bot ] ;

//virtualnode : virtNom2 : 0.95 : 1 : 
// [ cat:NN, base:unknown, person:bot, gender:bot, number:bot, case:nom_dat_acc, sort:bot ] ,
// [ cat:NN, base:unknown, person:bot, gender:bot, number:bot, case:gen        , sort:bot ] ;

// generic VERB
virtualnode : virtVerb : 0.95 : 1 :
 [base:unknown,cat:VVFIN,person:bot ,number:bot,tense:bot, gender: bot, mood:indicative,perfect:haben,valence:'acis?+d?'], 
 [base:unknown,cat:VVINF,valence:'acis?+d?'],
 [base:unknown,cat:VVPP,valence:'acis?+d?'],
 [base:unknown,cat:VVIZU,valence:'acis?+d?'];
// [base:virtuell,cat:VAFIN,perfect:haben,person:first,number:sg, gender: bot, valence:'ax+i?',avz:allowed,extravalence:d],
// [base:virtuell,cat:VAFIN,perfect:haben,person:second,number:sg,gender: bot, valence:'ax+i?',avz:allowed,extravalence:d],
// [base:virtuell,cat:VAFIN,perfect:haben,person:third,number:sg, gender: bot, valence:'ax+i?',avz:allowed,extravalence:d],
// [base:virtuell,cat:VAFIN,perfect:haben,person:first,number:pl, gender: bot, valence:'ax+i?',avz:allowed,extravalence:d],
// [base:virtuell,cat:VAFIN,perfect:haben,person:second,number:pl,gender: bot, valence:'ax+i?',avz:allowed,extravalence:d],
// [base:virtuell,cat:VAFIN,perfect:haben,person:third,number:pl, gender: bot, valence:'ax+i?',avz:allowed,extravalence:d];


// generic VA
//virtualnode : virtVA : 0.95 : 1 :
// [cat:VAFIN,base:sein,perfect:sein,person:bot,number:bot,valence:egx,avz:allowed,avz_valence:egx,extravalence:daci],
// [cat:VAFIN,base:haben,perfect:haben,person:bot,number:bot,valence:axi,avz:allowed,avz_valence:axi,extravalence:adi],
// [cat:VAFIN,base:werden,perfect:sein,person:bot,number:bot,objp:zu,valence:epx,avz:allowed,avz_valence:epx,extravalence:dag,extrasubjc:yes];


// generic AVZ
//virtualnode : virtPTKVZ : 0.95 : 1 :
// [ cat:PTKVZ, base:unknown];

// generic Konjunction
//virtualnode : virtKOUS : 0.95 : 1 : 
// [ cat:KOUS, base:unknown],
// [ cat:KOUS, base:unknown, Objektsatz_Konjunktion:yes];


// topDownPredictors
tdp : 'Transitivitt'    : 1 : @ : ( OBJA OBJD ) : ( virtNom ) ;
tdp : 'PN fehlt'         : 1 : @ : (PN) : ( virtNom ) ;
tdp : 'Beiordnung fehlt' : 1 : @ : (CJ) : ( virtNom virtVerb ) ;
tdp : 'Bitransitivitt'  : 1 : @ : ( OBJA OBJD ) : ( virtNom ) ;
tdp : 'Subjekt fehlt'    : 1 : @ : ( SUBJ ) : ( virtNom ) ;
// tdp : 'Konjunktion fr Verb fehlt' : 1 : @ : ( KON ) : ();
// tdp : 'Konjunktion fehlt' : 1 : @ : ( KON ) : ();
// tdp : 'Infinitiv ohne "zu"' : 1 : @ : (  ) : ( virtZu );




