// Extrem wichtig: In CDG-Kommentare sollen keine
// Makros expandiert werden. Anderenfalls knnte ein fehlendes
// ' in einem Kommentar einen Syntaxfehler erzeugen.
m4_changecom(`//',`
')

// Wenn wir dies nicht tten, knnten wir den Lexikoneintrag ` nicht
// deklarieren. 
m4_changequote(,)

m4_define(gradient, [ $1 / [ $1 + abs( distance(X@id, X^id) ) ] ])

m4_define(isa, subsumes(Features, $2, $1cat))
m4_define(isa2, subsumes(Features, $2, $1cat2))


m4_define(topicalized, 
  (parent($1^id, AUX) > $1@from & parent($1^id, AUX) < $1^from |
   parent($1^id, OBJI) > $1@from & parent($1^id, OBJI) < $1^from)
)

m4_define(edge, subsumes(Label, $2, $1.label))

m4_define(Partizipialadjektiv,
 ((  exists($1 partizipial1) | exists($1 partizipial2) ))
)

// Die berprfung von Kasuskongruenz ist besonders schwierig,
// weil sowohl voll spezifizierte als auch teilweise spezifizierte 
// Kasus im Lexikon vorkommen. Wo sicher ist, da einer der beiden
// Kasus voll spezifiziert ist, gengt ein subsumes(); wo aber
// zwei mglicherweise unterspezifizierte Kasus aufeinandertreffen
// knnen, etwa in Appositionen, mu man auerdem prfen, ob
// sie beide denselben atomaren Kasus subsumieren, etwa nom_dat_acc
// und gen_dat_acc.
m4_define(check_case,
 (( compatible(Features, $1, $2) |
    subsumes(Features, dat, $1) & subsumes(Features, dat, $2) |
    subsumes(Features, acc, $1) & subsumes(Features, acc, $2) |
    subsumes(Features, nom, $1) & subsumes(Features, nom, $2) |
    subsumes(Features, gen, $1) & subsumes(Features, gen, $2))))

m4_define(check_gender,
 (( compatible(Features, $1, $2) |
    subsumes(Features, $1, masc) & subsumes(Features, $2, masc) |
    subsumes(Features, $1, fem) & subsumes(Features, $2, fem) |
    subsumes(Features, $1, neut) & subsumes(Features, $2, neut))))

m4_define(case_specified,
 (($1 case=nom | $1case = gen | $1 case = dat | $1 case = acc)))

m4_define(initial,
 (( $1 cat = PWS | $1 cat = PRELS | $1 cat = PWAT | $1 cat = PWAV | $1 case = PRELAT |
    has($1 id, find_initial, Label, Skopus))))

m4_define(KON_PP,
  (($1 cat = APPR & exists($1 cat2) & $1 cat2 = KON)))

m4_define(quoted,
 ((phrasequotes($1 @id) > phrasequotes($1 ^id))))
