/*
 * Copyright (C) 1997-2011 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * profiling.h
 *
 *  Created on: 15.02.2011
 *      Author: beuck
 */

#include "timer.h"

#ifndef PROFILING_H_
#define PROFILING_H_

/* --- Type Definitions -----------  */
struct ProfilingMeasurePointStruct {
	String name;
	unsigned long time;
};
typedef struct ProfilingMeasurePointStruct ProfilingMeasurePointStruct, *ProfilingMeasurePoint;


struct ProfilingObjectStruct {
	List measurePoints;
	Hashtable contraintCount;
};
typedef struct ProfilingObjectStruct ProfilingObjectStruct, *ProfilingObject;


/* --- Procedures -----------  */
extern ProfilingMeasurePoint proMPointNew(String name, unsigned long time);
extern ProfilingObject proNew();
extern void proMerge(ProfilingObject prof1, ProfilingObject prof2);
extern void proMeasureTime(Timer timer, ProfilingObject prof, String name);

#endif /* PROFILING_H_ */
