/* 
 * Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
 *  
 * This file is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. For
 * more details read COPYING in the root of this distribution.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author: Jochen Hagenstroem (see also AUTHORS and THANKS for more)
 * ChangedBy: Timo Baumann (1baumann@...)
 * Purpose: header file for tagger related structures
 * Birth: 2001/02/07
 */

#ifndef TAGGER_H
#define TAGGER_H

#include "lexemgraph.h"

// flag positions for tagger feedback nodes
extern int TFM_RECENT_ONLY;
extern int TFM_CHANGED_ALWAYS;
extern int TFM_FIRST_CHANGE_BREAK;
extern int TFM_ONE_TAG_ONLY;

/* compiled index of the feature taggerCategoryPath */
extern int taggerCategoryIndex;
extern String taggerCategoryPath;

/* Is the tagger up? */
extern Boolean taggerUp(void);

/* things to do before running the tagger */
extern void taggerInitialize();

/* switch the tagger on/off */
extern int taggerStartStop();

/* manages i/o of the tagger specified in taggerCommand */
extern Boolean taggerTag(LexemGraph, List feedback);
extern List taggerCalculateFeedback(List selectedTags, List tagHistory, int delay);

/* retrieves the index associated with taggerCategoryPath */
extern Boolean taggerLookupCategoryIndex();

/* things to do before exit */
extern void taggerFinalize();

/* ---------------------------------------------------------------------- */
#endif /* don't insert anything after this #endif */

