#!@PERL@
# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

use warnings;
use strict;
use lib "@BINDINGSDIR@";
use CDG;

my $debug = 0;

sub testCmdEval
{
  my $command = shift;
  commandEval $command or die $command;
}

testCmdEval "set verbosity 0" if ! $debug;
testCmdEval "set debug on" if $debug;
testCmdEval "set preprocessor /bin/zcat";
testCmdEval "set prepsuffix .gz";
testCmdEval "load @TESTGRAMMAR@";

print "DEBUG: inputCurrentGrammar=$CDG::inputCurrentGrammar\n" if $debug;

print "DEBUG: getting lexiconItems\n" if $debug;
my $lexiconItems = InputStruct_lexicon_get($CDG::inputCurrentGrammar);
die "no lexicon found" if ! defined $lexiconItems;

print "DEBUG: hashIteratorNew\n" if $debug; 
my $hi = hashIteratorNew($lexiconItems); 

print "DEBUG: hashSize\n" if $debug; 
my $size = hashSize($lexiconItems);
die "no lexicon found\n" if !$size;

#print "hash size = $size\n";
my $noEntries = 0;
my $noForms = 0;
while (my $forms = hashIteratorNextValue($hi)) {
  print "DEBUG: LexiconItemStruct_word_get\n" if $debug; 
  my $word = LexiconItemStruct_word_get(ListStruct_item_get($forms));
  print "$word = " if $debug;

  for (my $l = $forms ;$l; $l = ListStruct_next_get($l)) {
    my $entry = ListStruct_item_get($l);
    my $id = LexiconItemStruct_description_get $entry;
    print "$id " if $debug;
    $noForms += 1;
  }
  print "\n" if $debug;
  $noEntries += 1;
}
cdgFinalize;
print "INFO: counted $noEntries lexicon entries with overall $noForms word forms\n" if $debug;

die "hash size is $size, but only counted $noEntries lexical entries\n"
  if $size != $noEntries;

