#!/bin/sh
#\
exec tclsh "$0" "$@" 
# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

source loadtclbindings

testCmdEval "set debug on"
testCmdEval "set preprocessor /bin/zcat";
testCmdEval "set prepsuffix .gz";
testCmdEval "load @TESTGRAMMAR@";

putsDebug "inputCurrentGrammar=[inputCurrentGrammar_get]\n" 
putsDebug "getting lexiconItems\n" 
set lexiconItems [InputStruct_lexicon_get [inputCurrentGrammar_get]];
if {$lexiconItems == 0 || $lexiconItems == "NULL"} {
  error "ERROR: lexiconItems=$lexiconItems"
}

putsDebug "hashIteratorNew\n"
set hi [hashIteratorNew $lexiconItems]; 

putsDebug "hashSize\n" 
set size [hashSize $lexiconItems];

if {$size <= 0} {
  error "ERROR: no lexicon found" 
}
putsDebug "size=$size\n"

set noEntries 0;
set noForms 0;
for {set forms [hashIteratorNextValue $hi]} {$forms != "NULL"} \
    {set forms [hashIteratorNextValue $hi]} {
  putsDebug "ListStruct_item_get forms=$forms\n"
  set item [ListStruct_item_get $forms]
  putsDebug "DEBUG: LexiconItemStruct_word_get item=$item\n"
  set word [LexiconItemStruct_word_get $item];
  putsDebug "$word = " 

  for {set l $forms} {$l != "NULL"} {set l [ListStruct_next_get $l]} {
    set entry [ListStruct_item_get $l];
    set id [LexiconItemStruct_description_get $entry];
    putsDebug "$id "
    incr noForms;
  }
  putsDebug "\n"
  incr noEntries;
}
cdgFinalize;
putsDebug "INFO: counted $noEntries lexicon entries with overall $noForms word forms\n"

if {$size != $noEntries} {
 error "ERROR: hash size is $size, but only counted $noEntries lexical entries"
}

