#!/bin/sh
#\
exec tclsh "$0" "$@" 
# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

lappend auto_path @BINDINGSDIR@
load @BINDINGSDIR@/tclcdg[info sharedlibextension]

set debug 0

if {$debug} {
  puts -nonewline "DEBUG: "
}
proc putsDebug {msg} {
  global debug
  if {!$debug} {
    return
  }
  regsub -all "\n" $msg "\nDEBUG: " msg
  puts -nonewline $msg
}

proc testCmdEval {command} {
  putsDebug "calling $command\n"
  set result [commandEval $command]
  if {!$result} {
    error "commandEval $command failed"
  }
  return $result
}

setHookCmd printf putsDebug

source ../xcdg/compat.tcl

