# Copyright (C) 1997-2005 The CDG Team <cdg@nats.informatik.uni-hamburg.de>
#  
# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. For
# more details read COPYING in the root of this distribution.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

## ----------------------------------------------------------------------------
## \file bugfix.tcl
## TclTk Enhancements.
## Fixes for some common errors in the TclTk, Itcl/Itk/Iwidges toolkits.
## Til now the most importand fix here is the iwidgets::Shell:activate{}
## fix to get arround the display delay of a shell dialog before it gets 
## accessable. You might have noticed that before in other TclTk apps, that
## sometimes you get a white box dialog. Whatever this is the activate()
## method below overwrites the Shell method in a way that things work better
## now. I don't clame to understand what I actually do here ;)
##
## \author Michael Daum
##
## ----------------------------------------------------------------------------

##----------------------------------------------------------------------------
## the shell widget is lame; this fixes it.
##----------------------------------------------------------------------------
body iwidgets::Shell::activate {} {

    if {[winfo ismapped $itk_component(hull)]} {
        raise $itk_component(hull) .
	return
    }
    
    if {($itk_option(-master) != {}) && \
	    [winfo exists $itk_option(-master)]} {
	wm transient $itk_component(hull) $itk_option(-master)
    } 

    set _wait($this) 0
    wm deiconify $itk_component(hull)
    if {$itk_option(-master) != ""} {
      raise $itk_component(hull) $itk_option(-master)
    } else {
      raise $itk_component(hull) .
    }
    tkwait visibility $itk_component(hull)
    
    if {$itk_option(-modality) == "application"} {
        if {$grabstack != {}} {
            grab release [lindex $grabstack end]
        }

	set err 1
	while {$err == 1} {
	    set err [catch [list grab $itk_component(hull)]]
	    if {$err == 1} {
		after 1000
	    }
	}

        lappend grabstack [list grab $itk_component(hull)]
        
        tkwait variable [scope _wait($this)]
        return $_result
        
    } elseif {$itk_option(-modality) == "global" }  {
        if {$grabstack != {}} {
            grab release [lindex $grabstack end]
        }

	set err 1
	while {$err == 1} {
	    set err [catch [list grab -global $itk_component(hull)]]
	    if {$err == 1} {
		after 1000
	    }
	}

        lappend grabstack [list grab -global $itk_component(hull)]
 
        tkwait variable [scope _wait($this)]
        return $_result
    }
}

##----------------------------------------------------------------------------
## remove tk8.4 bindings for the Panedwindow: we don't use it
##----------------------------------------------------------------------------
foreach event [bind Panedwindow] {
  bind Panedwindow $event {}
}
